<template>
  <SinglePane capt="Настройка рисков заказов">
    <div class="order-risks-settings-page">
      <div
        v-for="group in groups"
        :key="group.uuid"
        class="ob-accordion__item"
      >
        <div
          class="ob-accordion__title"
          @click="openAccordion(group)"
        >
          <i v-if="group._isOpen" class="icon chevron-down" />
          <i v-else class="icon chevron-right" />

          <div class="ob-accordion__title-text">
            {{ group.title }}
          </div>
        </div>

        <ObForm
          ref="riskForm"
          v-if="group._isOpen && group.uuid === 1"
          :form-data="{ risksSettings }"
          :is-loading="isRiskSavingPending"
          class="ob-accordion__content risk-wrapper"
          cancel-text="Отменить"
          @submit="putRiskSettings"
          @cancel="resetRisksSettings"
        >
          <div class="risk-container">
            <div class="risk-options">
              <div class="risk-options__title">
                Оценка стоимости груза
              </div>

              <div class="risk-options__item" v-html="formatCost(riskLevelOptions.absoluteMaxCost || riskLevelOptions.highMinCost, true)" />
              <div class="risk-options__item" v-html="formatCost(riskLevelOptions.highMinCost)" />
              <div class="risk-options__item" v-html="formatCost(riskLevelOptions.mediumMinCost)" />
              <div class="risk-options__item">0</div>
            </div>

            <div class="risk-elements">
              <div
                v-for="(risk, index) in risksSettings"
                :key="index"
                :style="getRiskStyle(risk.color)"
                class="grid-element"
              >
                <ObSelector
                  :items="riskGroups"
                  v-model="risk.color"
                  label="Уровень риска"
                  placeholder="Не настроен"
                  class="risk-select"
                />

                <div class="risk-durations">
                  <ObSelector
                    :key="`${index}-lowDuration`"
                    :items="riskGroups"
                    v-model="risk.lowDuration"
                    label="Короткий рейс"
                    placeholder="Не настроен"
                  />

                  <ObSelector
                    :key="`${index}-mediumDuration`"
                    :items="riskGroups"
                    v-model="risk.mediumDuration"
                    label="Средний рейс"
                    placeholder="Не настроен"
                  />

                  <ObSelector
                    :key="`${index}-highDuration`"
                    :items="riskGroups"
                    v-model="risk.highDuration"
                    label="Длинный рейс"
                    placeholder="Не настроен"
                  />
                </div>
              </div>
            </div>

            <div class="risk-grades">
              <div class="risk-grade">
                Низкая степень риска<br>
                утери груза
              </div>

              <div class="risk-grade">
                Средняя степень риска<br>
                утери груза
              </div>

              <div class="risk-grade">
                Высокая степень риска<br>
                утери груза
              </div>
            </div>
          </div>
        </ObForm>

        <ObForm
          ref="riskForm"
          v-if="group._isOpen && group.uuid === 2"
          :form-data="{ carrierRisksSettings }"
          :is-loading="isCarrierRiskSavingPending"
          class="ob-accordion__content carrier-risk-wrapper"
          cancel-text="Вернуть значения по умолчанию"
          @submit="putCarrierRiskSettings"
          @cancel="resetCarrierRiskSettings"
        >
          <div class="risk-level">
            <div class="risk-level__risks">
              <h4>
                Группа риска<br>
                перевозчика/ресурса
              </h4>

              <div
                v-for="(item, index) in riskGroups"
                :key="index"
              >
                <i :class="['icon', getRiskClass(item.color)]" />

                Группа риска {{index + 1}}
              </div>
            </div>

            <div class='risk-level__actions'>
              <div class='risk-level__grades'>
                <div class="risk-level__grade">
                  <h4>
                    Заказ<br>
                    с группой риска 1
                  </h4>
                </div>

                <div class="risk-level__grade">
                  <h4>
                    Заказ<br>
                    с группой риска 2
                  </h4>
                </div>

                <div class="risk-level__grade">
                  <h4>
                    Заказ<br>
                    с группой риска 3
                  </h4>
                </div>

                <div class="risk-level__grade">
                  <h4>
                    Заказ<br>
                    с группой риска 4
                  </h4>
                </div>

                <div class="risk-level__grade">
                  <h4>
                    Заказ<br>
                    с группой риска 5
                  </h4>
                </div>
              </div>

              <div
                class="risk-level__actions-item"
                v-for="(risk, index) in carrierRisksSettings"
                :key="index"
              >
                <div
                  :class="[
                    'risk-level__actions-toggle',
                    risk.isActive ? `risk-level__actions-toggle--${risk.cargoLossRiskColor.toLowerCase()}` : ''
                  ]"
                >
                  <ObSwitcher v-model="risk.isActive" />
                </div>
              </div>
            </div>
          </div>
        </ObForm>
      </div>
    </div>
  </SinglePane>
</template>

<script>
import api from "@/api";

import SinglePane from "common-components/src/obComponents/obSinglePanels";
import ObSelector from "common-components/src/obComponents/obSelect";
import ObSwitcher from "common-components/src/obComponents/obSwitcher";
import ObForm from "common-components/src/obComponents/obForm";
import riskIconMixin from "@/mixins/risk-icon";
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
import { COLORS_STYLES } from "@/resources/risk_colors";

export default {
  name: "order-risks-settings",
  mixins: [
    riskIconMixin,
    FormValidationMixin
  ],
  components: {
    SinglePane,
    ObSelector,
    ObSwitcher,
    ObForm
  },
  data () {
    return {
      groups: [
        {
          title: "Настройка уровня риска заказа",
          uuid: 1,
          _isOpen: true
        },
        {
          title: "Сопоставление заказа и перевозчика/ресурса по уровню рисков",
          uuid: 2,
          _isOpen: false
        }
      ],
      riskGroups: [],
      risksSettings: [
        {
          color: "",
          lossProbabilityLevel: "LOW",
          costLevel: "HIGH",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "MEDIUM",
          costLevel: "HIGH",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "HIGH",
          costLevel: "HIGH",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "LOW",
          costLevel: "MEDIUM",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "MEDIUM",
          costLevel: "MEDIUM",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "HIGH",
          costLevel: "MEDIUM",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "LOW",
          costLevel: "LOW",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "MEDIUM",
          costLevel: "LOW",
          description: ""
        },
        {
          color: "",
          lossProbabilityLevel: "HIGH",
          costLevel: "LOW",
          description: ""
        }
      ],
      riskLevelOptions: {},
      carrierRisksSettings: [
        {
          "cargoLossRiskColor": "GREEN",
          "carrierRiskColor": "GREEN",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "BLUE",
          "carrierRiskColor": "GREEN",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "YELLOW",
          "carrierRiskColor": "GREEN",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "ORANGE",
          "carrierRiskColor": "GREEN",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "RED",
          "carrierRiskColor": "GREEN",
          "isActive": false
        },

        {
          "cargoLossRiskColor": "GREEN",
          "carrierRiskColor": "BLUE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "BLUE",
          "carrierRiskColor": "BLUE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "YELLOW",
          "carrierRiskColor": "BLUE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "ORANGE",
          "carrierRiskColor": "BLUE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "RED",
          "carrierRiskColor": "BLUE",
          "isActive": false
        },

        {
          "cargoLossRiskColor": "GREEN",
          "carrierRiskColor": "YELLOW",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "BLUE",
          "carrierRiskColor": "YELLOW",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "YELLOW",
          "carrierRiskColor": "YELLOW",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "ORANGE",
          "carrierRiskColor": "YELLOW",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "RED",
          "carrierRiskColor": "YELLOW",
          "isActive": false
        },

        {
          "cargoLossRiskColor": "GREEN",
          "carrierRiskColor": "ORANGE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "BLUE",
          "carrierRiskColor": "ORANGE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "YELLOW",
          "carrierRiskColor": "ORANGE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "ORANGE",
          "carrierRiskColor": "ORANGE",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "RED",
          "carrierRiskColor": "ORANGE",
          "isActive": false
        },

        {
          "cargoLossRiskColor": "GREEN",
          "carrierRiskColor": "RED",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "BLUE",
          "carrierRiskColor": "RED",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "YELLOW",
          "carrierRiskColor": "RED",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "ORANGE",
          "carrierRiskColor": "RED",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "RED",
          "carrierRiskColor": "RED",
          "isActive": false
        },

        {
          "cargoLossRiskColor": "GREEN",
          "carrierRiskColor": "BLACK",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "BLUE",
          "carrierRiskColor": "BLACK",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "YELLOW",
          "carrierRiskColor": "BLACK",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "ORANGE",
          "carrierRiskColor": "BLACK",
          "isActive": false
        },
        {
          "cargoLossRiskColor": "RED",
          "carrierRiskColor": "BLACK",
          "isActive": false
        }
      ],
      isRiskSavingPending: false,
      isCarrierRiskSavingPending: false
    };
  },
  methods: {
    async fetch() {
      const riskLevel = await this.getRisksSettings();
      const riskLevelOptions = await this.getRisksSettingsOptions();
      const carrierRisk = await this.getCarrierRiskSettings();

      if (riskLevel?.length) {
        riskLevel.forEach(group => {
          const found = this.risksSettings.find(setting => {
            return (
              setting.lossProbabilityLevel === group.lossProbabilityLevel &&
              setting.costLevel === group.costLevel
            );
          });

          const findRiskColorUuid = (key) => {
            this.$set(found, key, this.riskGroups.find(risk => risk.color === group[key])?.uuid);
          }

          findRiskColorUuid('color');
          findRiskColorUuid('lowDuration');
          findRiskColorUuid('mediumDuration');
          findRiskColorUuid('highDuration');
        });
      }

      if (riskLevelOptions) {
        this.riskLevelOptions = riskLevelOptions;
      }

      if (carrierRisk?.length) {
        carrierRisk.forEach(item => {
          const found = this.carrierRisksSettings.find(setting => {
            return (
              setting.cargoLossRiskColor === item.cargoLossRiskColor && setting.carrierRiskColor === item.carrierRiskColor
            );
          });

          found.isActive = item.active;
        })
      }

      // To reset 'initFormData'
      this.$refs.riskForm.forEach(form => form.resetForm());
    },

    async putRiskSettings() {
      this.isRiskSavingPending = true

      const notificationId = new Date().getTime() + 'save';

      this.$notification({
        id: notificationId,
        type: 'system_notification_in_load',
        message: 'Сохранение'
      });

      try {
        const findColorNameByUuid = (colors, key) => this.riskGroups.find(risk => risk.uuid === colors[key]).color

        const payload = this.risksSettings
          .filter(setting => setting.color)
          .map(setting => {
            return {
              ...setting,
              color: findColorNameByUuid(setting, 'color'),
              lowDuration: findColorNameByUuid(setting, 'lowDuration'),
              mediumDuration: findColorNameByUuid(setting, 'mediumDuration'),
              highDuration: findColorNameByUuid(setting, 'highDuration'),
            };
          });

        await api.orderRisksSettings.putRisksSettings(payload);

        this.fetch();

        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      } catch (e) {
        console.error(e);

        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      }

      this.$notification({
        event: 'close',
        id: notificationId
      })

      this.isRiskSavingPending = false
    },

    async putCarrierRiskSettings() {
      this.isCarrierRiskSavingPending = true

      const notificationId = new Date().getTime() + 'save';

      this.$notification({
        id: notificationId,
        type: 'system_notification_in_load',
        message: 'Сохранение'
      });

      try {
        const payload = this.carrierRisksSettings.filter(setting => setting.isActive);

        await api.orderRisksSettings.putRiskCarrierSettings(payload);

        this.fetch();

        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      } catch (e) {
        console.error(e);

        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      }

      this.$notification({
        event: 'close',
        id: notificationId
      })

      this.isCarrierRiskSavingPending = false
    },

    async getRisksSettings() {
      try {
        const response = await api.orderRisksSettings.getRisksSettings();
        return response;
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },

    async resetRisksSettings() {
      this.isRiskSavingPending = true

      const notificationId = new Date().getTime() + 'save';

      this.$notification({
        id: notificationId,
        type: 'system_notification_in_load',
        message: 'Отмена'
      });

      this.risksSettings.forEach(item => item.color = "")

      const riskLevel = await this.getRisksSettings();

      if (riskLevel?.length) {
        riskLevel.forEach(group => {
          const found = this.risksSettings.find(setting => {
            return (
              setting.lossProbabilityLevel === group.lossProbabilityLevel &&
              setting.costLevel === group.costLevel
            );
          });

          found.color = this.riskGroups.find(risk => risk.color === group.color).uuid;
        });
      }

      this.$notification({
        event: 'close',
        id: notificationId
      })

      this.$notification({
        type: 'system_notification_success',
        message: 'Отмена прошла успешно'
      })

      this.isRiskSavingPending = false
    },

    async getRisksSettingsOptions() {
      const response = await api.orderRisksSettings.getRiskSettingsOptions();
      return response;
    },

    async getCarrierRiskSettings() {
      try {
        const response = await api.orderRisksSettings.getRiskCarrierSettings();
        return response;
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },

    async resetCarrierRiskSettings() {
      this.isCarrierRiskSavingPending = true

      const notificationId = new Date().getTime() + 'save';

      this.$notification({
        id: notificationId,
        type: 'system_notification_in_load',
        message: 'Восстановление значений по-умолчанию'
      });

      this.carrierRisksSettings.forEach(item => item.isActive = false)

      const carrierRisk = await this.getCarrierRiskSettings();

      if (carrierRisk?.length) {
        carrierRisk.forEach(item => {
          const found = this.carrierRisksSettings.find(setting => {
            return (
              setting.cargoLossRiskColor === item.cargoLossRiskColor && setting.carrierRiskColor === item.carrierRiskColor
            );
          });

          found.isActive = item.active;
        })
      }

      this.$notification({
        event: 'close',
        id: notificationId
      })

      this.$notification({
        type: 'system_notification_success',
        message: 'Значения по-умолчанию восстановлены'
      })

      this.isCarrierRiskSavingPending = false
    },

    async getRisksGroups() {
      try {
        const response = await api.card.getRiskGroups();

        this.riskGroups = response.map(({icon, ...keepAttrs}) => {
          icon; // Nice no unused vars in linter
          return {...keepAttrs, icon: this.getRiskClass(keepAttrs.color)};
        });
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },

    getRiskStyle(uuid) {
      const risk = this.riskGroups.find(risk => risk.uuid === uuid);
      const styles = risk ? COLORS_STYLES[risk.color] : null;
      return styles;
    },

    openAccordion(group) {
      group._isOpen = !group._isOpen;
    },

    formatCost(value, withPrefix = false) {
      if (!value) {
        return '0 ₽'
      }

      let result = ''

      if (withPrefix) {
        result += '<p>свыше</p>'
      }

      if (value) {
        result += `${new Intl.NumberFormat("ru-RU").format(value / 100)} ₽`
      }

      return result
    }
  },
  async mounted() {
    await this.getRisksGroups();
    await this.fetch();
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.risk-wrapper {
  padding: 86px 65px 0 44px;
  margin-bottom: 44px;
}

.carrier-risk-wrapper {
  padding: 30px 40px;
}

.risk-container {
  position: relative;
  display: grid;
  grid-template-areas:
    'risk-options risk-elements'
    '.            risk-grades';
  grid-template-columns: 140px 1fr;
}

.risk-options {
  @include font-mixin(16px, 20px, 400, $color-grey-span);

  grid-area: risk-options;
  position: relative;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  margin-right: 15px;
  text-align: right;

  &__title {
    @include font-mixin(12px, 14px, 400, $color-grey-span, 1.6px, uppercase);

    position: absolute;
    right: 0;
    bottom: calc(100% + 20px);
  }

  &__item {
    @include font-mixin(14px, 16px, 400, $color-grey-span);

    white-space: nowrap;
  }
}

.risk-elements {
  grid-area: risk-elements;

  flex-grow: 1;
  display: grid;
  grid-gap: 1px;
  grid-template-columns: repeat(3, 1fr);
  border-left: 2px solid $color-grey-border;
  border-bottom: 2px solid $color-grey-border;
  padding: 0 0 30px 30px;
  position: relative;
  border-radius: 0 0 0 4px;

  &::after,
  &::before {
    content: '';
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    border: solid $color-grey-border;
    border-width: 0 2px 2px 0;
    display: inline-block;
    padding: 5px;
    border-radius: 0 0 4px 0;
  }

  &::before {
    bottom: auto;
    right: auto;
    left: -7px;
    transform: rotate(-135deg);
  }

  &::after {
    top: auto;
    left: auto;
    bottom: -7px;
    transform: rotate(-45deg);
  }
}

.grid-element {
  box-sizing: border-box;
  padding: 32px 20px 28px;
  border-radius: 4px;
  background-color: #c4c4c4;

  &::v-deep {
    .ob-selector__value {
      display: flex;
      align-items: center;
    }

    .ob-selector__value-html {
      display: flex;
    }
  }
}

.risk-select {
  margin-bottom: 17px;
}

.risk-durations {
  display: grid;
  grid-auto-flow: column;
  grid-auto-columns: min-content;
  justify-content: space-between;
  padding: 9px 15px;
  border-radius: 4px;
  background-color: $style-white;

  $size: 23px;

  &::v-deep {
    .ob-selector {
      &__select {
        border: none;
        border-radius: 0;

        &_open {
          border: none !important;
        }
      }

      &__label {
        color: $style-black;
        margin: 0;
      }

      &__controls {
        margin: 0;

        .icon {
          position: absolute;
          top: 24px;
          left: 25px;
        }
      }

      &__value {
        margin: 0;
        font-size: 0;
      }

      &__value-icon[class*='risk'] {
        width: $size;
        height: $size;
        font-size: $size;
        margin-left: 1px;
        padding-top: 1px;

        &::before {
          width: $size;
          height: $size;
        }
      }
    }
  }
}

.risk-grades {
  grid-area: risk-grades;
  display: grid;
  grid-auto-flow: column;
  grid-auto-columns: 1fr;
  align-items: center;
  padding: 15px 0 0 30px;
}

.risk-grade {
  @include font-mixin(12px, 16px, 400, $color-grey-span, 0.2px, uppercase);

  text-align: center;
}

.ob-accordion {
  display: flex;
  background: $background-white;
  flex-direction: column;
  width: 100%;

  &__header {
    display: flex;
    width: 100%;
    height: 40px;
    padding-left: 44px;
    border-bottom: 1px solid $lavender;

    &-item {
      display: flex;
      flex-direction: column;
      justify-content: center;
      color: $shale-gray;
      font-size: 11px;
      line-height: 12px;
      font-variant: small-caps;
      text-transform: uppercase;
      flex-basis: 20%;

      &:nth-child(3) {
        flex-basis: 10%;
      }
      &:nth-child(4) {
        flex-basis: 50%;
      }
    }
  }
  &__item {
    display: flex;
    flex-direction: column;
    border-left: none;
    border-right: none;
  }
  &__title {
    padding: 21px 15px 22px;
    color: $color-blue-navy-blue;
    display: flex;
    cursor: pointer;
    font-size: 14px;
    border-bottom: 1px solid $lavender;
    background-color: $light-lavender;

    &-text {
      margin-left: 15px;
    }
  }

  &__content {
    &-table {
      width: 100%;
      &-row {
        display: flex;
        border-bottom: 1px solid $lavender;
        padding: 8px 0;
        padding-left: 44px;
        min-height: 40px;
      }
      &-cell {
        display: flex;
        flex-direction: column;
        justify-content: center;
        font-size: 14px;
        line-height: 20px;
        flex-basis: 20%;
        color: $color-text-base;
        &:nth-child(3) {
          flex-basis: 10%;
          align-items: center;
        }
        &:nth-child(4) {
          flex-basis: 50%;
          i {
            margin-left: 6px;
          }
        }
      }
    }
  }
}

h4 {
  margin-bottom: 40px;
  font-weight: bold;
  font-size: 12px;
  line-height: 16px;
  letter-spacing: 1.6px;
  text-transform: uppercase;
  color: $color-grey-span;
}

.risk-level {
  display: flex;
}

.risk-level__risks {
  min-width: 200px;
  margin-right: 40px;
  font-weight: bold;
  font-size: 14px;
  line-height: 20px;
  letter-spacing: 0.2px;
  color: $color-text-base;

  & > div {
    height: 72px;
    margin-top: 2px;
    display: flex;
    align-items: center;
  }

  .icon {
    font-size: 18px;
    margin-right: 9px;
  }
}

.risk-level__actions {
  flex-grow: 1;
  display: flex;
  flex-wrap: wrap;
}

.risk-level__grades {
  width: 100%;
  display: flex;
}

.risk-level__grade {
  width: 20%;
}

.risk-level__actions-item {
  width: calc((100% - 10px) / 5);
  margin-right: 2px;
}

.risk-level__actions-toggle {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 72px;
  margin-top: 2px;
  background-color: $orderRisksSettingsPage-risk_level_actions_toggle_background-color;

  &--green {
    background-color: $color-green-light;
  }

  &--blue {
    background-color: $orderRisksSettingsPage-risk_level_actions_toggle_blue-background-color;
  }

  &--yellow {
    background-color: $gorse-yellow;
  }

  &--orange {
    background-color: $diamond-orange-yellow;
  }

  &--red {
    background-color: $color-error;
  }
}
</style>
